



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Async/Await - Best Practices in Asynchronous Programming</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Async/Await - Best Practices in Asynchronous Programming</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 05:57:06 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>https://msdn.microsoft.com/en-us/magazine/jj991977.aspx</p>
<div>
<p><strong>Figure 1 Summary of Asynchronous Programming Guidelines</strong></p>
</div>
<table>
<tbody>
<tr>
<td>Name</td>
<td>Description</td>
<td>Exceptions</td>
</tr>
<tr>
<td>Avoid async void</td>
<td>Prefer async Task methods over async void methods</td>
<td>Event handlers</td>
</tr>
<tr>
<td>Async all the way</td>
<td>Don&rsquo;t mix blocking and async code</td>
<td>Console main method</td>
</tr>
<tr>
<td>Configure context</td>
<td>Use ConfigureAwait(false) when you can</td>
<td>Methods that require con&shy;text</td>
</tr>
</tbody>
</table>
<div>
<h2>Avoid Async Void</h2>
</div>
<p>You should prefer "async Task" to "async void". Async Task methods enable easier error-handling(propagate up or not), composability (Task.waitAll ...)&nbsp;and testability. The exception to this guideline is asynchronous event handlers, which must return void. This exception includes methods that are logically event handlers even if they&rsquo;re not literally event handlers (for example, ICommand.Execute implementations).</p>
<h2>Async All the Way</h2>
<p>"Async all the way&rdquo; means that you shouldn&rsquo;t mix synchronous and asynchronous code without carefully considering the consequences. In particular, it&rsquo;s usually a bad idea to block on async code by calling Task.Wait or Task.Result.&nbsp;&nbsp;This is an common problem for programmers who try to convert just a small part of their application and wrapping it in a synchronous API so the rest of the application is isolated from the changes. Unfortunately, this can cause deadlocks, in the case of GUI or ASP.NET (not if in a console application). The exception semantic for await and Task.Wait is also different, Exception versus AggregateException. So do not do this except in the Main method for console applications.</p>
<div>
<p><strong>Figure 5 The &ldquo;Async Way&rdquo; of Doing Things</strong></p>
</div>
<table>
<tbody>
<tr>
<td>To Do This &hellip;</td>
<td>Instead of This &hellip;</td>
<td>Use This</td>
</tr>
<tr>
<td>Retrieve the result of a background task</td>
<td>Task.Wait or Task.Result</td>
<td>await</td>
</tr>
<tr>
<td>Wait for any task to complete</td>
<td>Task.WaitAny</td>
<td>await Task.WhenAny</td>
</tr>
<tr>
<td>Retrieve the results of multiple tasks</td>
<td>Task.WaitAll</td>
<td>await Task.WhenAll</td>
</tr>
<tr>
<td>Wait a period of time</td>
<td>Thread.Sleep</td>
<td>await Task.Delay</td>
</tr>
</tbody>
</table>
<h2>Configure Context</h2>
<p>Await require context, see the following code, if you swap the commented-out lines in DelayAsync, it will not deadlock,</p>
<pre class="prettyprint linenums">public static class DeadlockDemo<br />
{<br />
&nbsp; private static async Task DelayAsync()<br />
&nbsp; {<br />
&nbsp;&nbsp;&nbsp; await Task.Delay(1000);<br />　　//await Task.Delay(1000).ConfigureAwait(continueOnCapturedContext: false);</pre>
<pre class="prettyprint linenums">&nbsp; } &nbsp; // This method causes a deadlock when called in a GUI or ASP.NET context.<br />　　public static void Test() &nbsp; <br />　　{ &nbsp;&nbsp;&nbsp; // Start the delay. &nbsp;&nbsp;&nbsp; <br />　　　　var delayTask = DelayAsync(); &nbsp;&nbsp;&nbsp; // Wait for the delay to complete. &nbsp;&nbsp;&nbsp; <br />　　　　delayTask.Wait(); &nbsp; <br />　　} <br />}</pre>
<p>This technique is particularly useful if you need to gradually convert an application from synchronous to asynchronous.</p>
<p>You should not use ConfigureAwait when you have code after the await in the method that needs the context.</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r0llr9.html">sh back mongo</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq437ze8.html">【原创】Kakfa log包源代码分析&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gkgjz8.html">Python 序列通用操作介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1n4329.html">HDU 5014 Number Sequence（位运算）</a>
		</li>
						<li><a href="https://www.batexi.com/a/m962174q.html">使用SDWebImage下载图片&comma;sharedDownloader方法下载成功&comma;new 方法下载失败</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m40628.html">mybatis动态SQL标签的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw3ov39.html">sql跨数据库转移</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvgznzq.html">Sublime Text3注册码（可用）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z5dg59.html">VS2013编译OpenSSL</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydrry2q.html">BeginInvoke、ThreadPool、Task三类异步方法的区别和速度比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rd0mn78.html">教你21天学会C&plus;&plus; （有图有真相）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1r2rr9.html">Unity3D如何获取对象和子对象</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdld2r8.html">设计模式之（三）Proxy模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkwdlj8.html">SharePoint代码段设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/96poxjn8.html">开放源代码的微微信&period;NET 0&period;8 版公布了</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj20zj8.html">Voilin 与 乐谱</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv17jv1q.html">ATL环境：设置父窗口激活属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2my2pq.html">python 【pandas】读取excel、csv数据，提高索引速度</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jj0jnq.html">DLCI 简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2z0nj9.html">利用curl 实现URL监控</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9jp50l9.html">longjmp setjmp and volatile</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o5mpl9.html">asp&period;net中关于Microsoft 信息完整性、隐私性等集成信息安全服务服务    integrated security&equals;SSPI</a>
			</li>
						<li><a href="https://www.batexi.com/a/495j6p0q.html">iOS开发一个用户登录注册模块需要解决的坑</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4nxve9.html">U盘被写保护如何解除 &lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdze5j9.html">yii开发一个web程序的基本流程</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1lz368.html">UIKit框架之UIGestureRecognizer</a>
			</li>
						<li><a href="https://www.batexi.com/a/390pmr38.html">CSS Animation</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qx5kyd8.html">MySQL日期时间函数大全 转</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9p3d7kq.html">Silverlight behavior&lpar;行为&rpar; trigger 大全</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnyvd28.html">jQuery的常见操作</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
